/*
 * Include File < graphs3_.h >
 *
 * 3-D Stereo Graphics Interface for BGI
 *
 * Copyleft (c) 1991-1993 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHS3__H_
#define _GRAPHS3__H_
#include <graphp3_.h>

/*
  3ƥ쥪եåѥå
  
  3βžɸϤ2ƩѴܤ,륹ƥ쥪եå
  ¸뤿ΥѥåǤ.
  ̿'sl_'ղäΤѤ̿,
  'sr_'ղäΤѤ̿Ǥ.
  ޤ,Ʊ̿ѰդƤ, ̿'s3_'
  ղä̾ΤˤʤäƤޤ. ǥեͤǺѴֿ򥻥å,
  ѴĿ򥻥åȤԤޤ. ѹǽǤ.
  㤨Хǥץ쥤˥ƥ쥪եåľ(X:0..1,Y:0..2,Z:0..3)
  ˤϰʲΤ褦ˤޤ.
    setviewport_( 0, 100, 0, 100, !0 );   ̤100x100ΰȤ
    setwindow_( -1, 1, 1, -1 );           Ȥɺɸ
    setrotationport_( 0, 0, 0, 1, 2, 3 ); ˾βžɸϤ
    setrotation_( RAD(-15), RAD(20), 0 ); žѤ
    setdistance_( 0.5 );                  Υ
    stereodistance_( 0.5 );               ƥ쥪ջΥ
    cubes3_( 0, 0, 0, 1, 2, 3, !0 );      žɸϤƱľΤ
 */

static void _sLproc(void)
{
  setcolor( LIGHTRED );
}
static void _sRproc(void)
{
  setcolor( LIGHTBLUE );
}
static void (*sLproc)(void) = _sLproc, (*sRproc)(void) = _sRproc;
static void setstereoLproc( void (*proc)(void) )
{
  sLproc = proc;
}
static void setstereoRproc( void (*proc)(void) )
{
  sRproc = proc;
}
static double _SD = (1.0/0.5)/100;
/*
 * macros for stereo L space to R2 space
 */
#define sltox(x,y,z) ((r3tox(x,y,z)+_SD)*_PV/(r3toz(x,y,z)+_P3TH))
#define sltoy(x,y,z) p3toy(x,y,z)
#define sltoz(x,y,z) p3toz(x,y,z)
/*
 * macros for stereo R space to R2 space
 */
#define srtox(x,y,z) ((r3tox(x,y,z)-_SD)*_PV/(r3toz(x,y,z)+_P3TH))
#define srtoy(x,y,z) p3toy(x,y,z)
#define srtoz(x,y,z) p3toz(x,y,z)
/*
 * mocros to draw object by left eye
 */
#define linesl_(x1,y1,z1,x2,y2,z2) \
                             line_(sltox(x1,y1,z1),sltoy(x1,y1,z1), \
                                   sltox(x2,y2,z2),sltoy(x2,y2,z2))
#define linetosl_(x,y,z)     lineto_(sltox(x,y,z),sltoy(x,y,z))
#define putpixelsl_(x,y,z,c) putpixel_(sltox(x,y,z),sltoy(x,y,z),c)
#define movetosl_(x,y,z)     moveto_(sltox(x,y,z),sltoy(x,y,z))
#define outtextxysl_(x,y,z,str) \
                             outtextxy_(sltox(x,y,z),sltoy(x,y,z),str)
/*
 * mocros to draw object by right eye
 */
#define linesr_(x1,y1,z1,x2,y2,z2) \
                             line_(srtox(x1,y1,z1),srtoy(x1,y1,z1), \
                                   srtox(x2,y2,z2),srtoy(x2,y2,z2))
#define linetosr_(x,y,z)     lineto_(srtox(x,y,z),srtoy(x,y,z))
#define putpixelsr_(x,y,z,c) putpixel_(srtox(x,y,z),srtoy(x,y,z),c)
#define movetosr_(x,y,z)     moveto_(srtox(x,y,z),srtoy(x,y,z))
#define outtextxysr_(x,y,z,str) \
                             outtextxy_(srtox(x,y,z),srtoy(x,y,z),str)
/*
 * mocros to draw object by eyes
 */
#define lines3_(x1,y1,z1,x2,y2,z2) \
                               do{sLproc();linesl_(x1,y1,z1,x2,y2,z2); \
                                  sRproc();linesr_(x1,y1,z1,x2,y2,z2);}while(0)
#define linetos3_(x,y,z)       do{sLproc();linetosl_(x,y,z); \
                                  sRproc();linetosr_(x,y,z);}while(0)
#define movetos3_(x,y,z)       do{sLproc();movetosl_(x,y,z); \
                                  sRproc();movetosr_(x,y,z);}while(0)
#define outtextxys3_(x,y,z,str) \
                               do{sLproc();outtextxysl_(x,y,z,str); \
                                  sRproc();outtextxysr_(x,y,z,str);}while(0)
/*
 * function to set stereo distance
 */
void stereodistance_( double d )
{
  _SD = (1.0/d)/100;
}
/*
 * function to draw cubic
 */
static void cubes3_( double xf, double yf, double zf,
                    double xt, double yt, double zt, int flg )
{
  int i, maxi;
  double x0, y0, z0, x1, y1, z1, maxz, z;
  static int l[12][2] = {
    { 0, 1 }, { 0, 2 }, { 0, 4 },
    { 1, 3 }, { 1, 5 },
    { 2, 3 },
    { 5, 4 },
    { 6, 4 }, { 6, 2 },
    { 7, 6 }, { 7, 5 }, { 7, 3 }, 
  };
  struct linesettingstype ls;

  getlinesettings( &ls );
  maxz = r3toz( xf, yf, zf );
  maxi = 0;
  for ( i=1; i<8; i++ ){
    x0 = (i/1%2)?xt:xf;
    y0 = (i/2%2)?yt:yf;
    z0 = (i/4%2)?zt:zf;
    z = r3toz( x0, y0, z0 );
    if ( z>maxz ){
      maxz = z;
      maxi = i;
    }
  }
  for ( i=0; i<12; i++ ){
    x0 = (l[i][0]/1%2)?xt:xf; x1 = (l[i][1]/1%2)?xt:xf;
    y0 = (l[i][0]/2%2)?yt:yf; y1 = (l[i][1]/2%2)?yt:yf;
    z0 = (l[i][0]/4%2)?zt:zf; z1 = (l[i][1]/4%2)?zt:zf;
    if ((flg)&&( l[i][0]==maxi )||( l[i][1]==maxi ))
      setlinestyle( DOTTED_LINE, 0, NORM_WIDTH );
    else
      setlinestyle( SOLID_LINE, 0, NORM_WIDTH );
    lines3_( x0, y0, z0, x1, y1, z1 );
  }
  setlinestyle( ls.linestyle, ls.upattern, ls.thickness );
}

#endif /* _GRAPHS3__H_ */
