/*
 * Header File < graphix.h >
 *
 * Enhanced Functions: Borland Graphics Interface for Xlib
 *
 * Copyleft (c) 1993 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHIX_H_
#define _GRAPHIX_H_

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>
#include <X11/xpm.h>
#include "graphics.h"

struct rgbtype {
  unsigned char r, g, b;
};

typedef struct _xbgi {
  int id;
  Display *dpy;
  Visual *vis;
  int scr;
  int depth;
  int vclass;
  Window root;
  Window *win;
  GC gc;
  char configure_ev_key;
  XEvent key_press_ev;
  XEvent button_press_ev, button_release_ev;
  unsigned long fg, bg, lc, dc;
  XFontStruct *fs, *fsp;
  Colormap colormap;
  unsigned char colortable[256];
  unsigned long pixels[MAXCOLORS+1];
  GC gcdraw, gcfill, gcpixel, gcimage;
  int gdriver, gmode, gerror;
  int npage, apage, vpage;
  int ncolor, color, bkcolor;
  struct pointtype cp;
  struct viewporttype viewport;
  struct linesettingstype lineset;
  struct textsettingstype textset;
  struct fillsettingstype fillset;
  struct palettetype palette;
  struct rgbtype rgb[MAXCOLORS+1];
  struct _xbgi *next;
} xbgi;

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

extern xbgi *creategraph(
#if NeedFunctionPrototypes
  int *__graphdriver, int *__graphmode, char *__pathtodriver
#endif
);

extern xbgi *thisgraph(
#if NeedFunctionPrototypes
  void
#endif
);

extern void destroygraph(
#if NeedFunctionPrototypes
  xbgi *__this
#endif
);

extern void currentgraph(
#if NeedFunctionPrototypes
  xbgi *__this
#endif
);

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif /* _GRAPHIX_H_ */
