/*
 * routines to analyse command line options < option.h >
 *
 * ޥɥ饤󥪥ץϤΤΥ롼
 *
 * copyright (c) 1992 Taiji YAMADA
 */
#ifndef _OPTION_H_
#define _OPTION_H_
#include <stdarg.h>
#include <string.h>

/*
 * 1. if there is key to scan in command line options, true is returned.
 * (ex.) if there is "-help" in command line options
 *       scan_option( argc, argv, "-help" ) returns !0
 *
 * 2. if there is key to scan with scanf format,
 *   value(s) is(are) scaned and true(=scanf return value) is returned.
 * (ex.) if there is "-geom 100x100" in command line options
 *       scan_option( argc, argv, "-geom %dx%d", &W, &H ) returns 2 and
 *       sets W, H to 100, 100 respectively.
 */
/*
 * 1. ޥɥ饤󥪥ץ˻ꤵ줿 key ¸ߤ, ֤.
 * () ޥɥ饤 "-help" ꤵƤ
 *      scan_option( argc, argv, "-help" ) ֤, .
 *
 * 2. ޥɥ饤󥪥ץ˻ꤵ줿 key ¸ߤ,
 *   key  scanf 񼰤ľ, key ΤȤ˻ꤵ줿Ѱ
 *  ޥɥ饤ͤ򥻥åȤ, Ԥ줿ο֤.
 * () ޥɥ饤 "-geom 100x100" ˤ
 *       scan_option( argc, argv, "-geom %dx%d", &W, &H )  2 ֤,
 *       W, H ˤϤ줾 100, 100 .
 */
#ifdef ENABLE_VSSCANF
static int scan_option( int argc, char *argv[], char *key, ... )
#else
static int scan_option( argc, argv, key, v0,v1,v2,v3,v4,v5,v6,v7,v8,v9 )
int argc;
char **argv, *key;
void *v0,*v1,*v2,*v3,*v4,*v5,*v6,*v7,*v8,*v9;
#endif
{
  int i, j, ret;
  char opt[64], buf[256], fmt[256], *p;

#ifdef ENABLE_VSSCANF
  va_list argptr;
  va_start( argptr, key );
#endif

  strcpy( opt, key );
  if ( (p=strchr(opt,'%'))!=NULL ){
    strcpy( fmt, opt );
    *p = '\0';
  }else{
    for ( i=1; i<argc; i++ )
      if ( strcmp( argv[i], key )==0 )
        return i;
    return( 0 );
  }
  while ( *(--p)==' ' ) *p = '\0';
  
  for ( i=1; i<argc; i++ )
    if ( strstr( argv[i], opt ) == argv[i] ){
      j = i;
      strcpy( buf, argv[j] );
      while ( ++j<argc ){
        strcat( buf, " " );
        strcat( buf, argv[j] );
      }
#ifdef ENABLE_VSSCANF
      ret = vsscanf( buf, fmt, argptr );
#else
      ret = sscanf( buf, fmt, v0,v1,v2,v3,v4,v5,v6,v7,v8,v9 );
#endif
      return ret;
    }
#ifdef ENABLE_VSSCANF
  va_end( argptr );
#endif
  return 0;
}
/*
 *  following methods do not work in place of vsscanf
 *   ret = sscanf( buf, fmt, _va_ptr );
 *   ret = sscanf( buf, fmt, argptr );
 *   ret = vfscanf( buf, fmt, argptr );
 */

#endif /* _OPTION_H_ */
