#include <stdio.h>
#include <math.h>
#include <graphr2_.h>
#define MAXTIME 50000
double K = 0.7, ALPHA = 1, EPS = 0.02;
double Y0[2] = {0.1,-0.1}, Y1[2];
double a[2] = {0.032,0.138};
double W[2][2] = {{0,0.558},{0.558,0}};
double func_f( double yt )
{
  return( 1.0/(1.0+exp(-yt/EPS)) );
}
double func_yi( double yt, double a )
{
  return( K*yt - ALPHA*func_f( yt ) + a );
}
void iterate( void )
{
  int n;

  Y1[0] = func_yi( Y0[0], a[0]+W[0][1]*func_f( Y0[1] ) );
  Y1[1] = func_yi( Y0[1], a[1]+W[1][0]*func_f( Y0[0] ) );
  putpixel_( Y1[0], Y1[1], getcolor() );
  for ( n=0; n<2; n++ )
    Y0[n] = Y1[n];
}
void main( void )
{
  int gd = DETECT, gm, i;

  initgraph_( &gd, &gm, "-geometry 520x520" );
  setviewport_( 10, 10, 510-1, 510-1, !0 );
  setwindow_( -1.0, 1.0, 1.0, -1.0 );
  rectangle_( -1.0, 1.0, 1.0, -1.0 );
  for ( i=0; i<MAXTIME; i++ ){
    iterate();
  }
  xbgiloop();
  closegraph();
}
