/*
 * }fuW fʑ̌vZ
 *
 * yn+1yn^2{b ... (1)
 *
 * The iteration of mappings of the complex plane.
 */
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <graphix_.h>
/*
 * [U[`̔zF
 */
int mycolor[16][3]={
  {  0,  0,  0 },
  {  0,  0,  2 },
  {  0,  0,  4 },
  {  0,  0,  6 },
  {  0,  0,  8 },
  {  0,  0, 10 },
  {  0,  0, 12 },
  {  0,  0, 14 },
  {  0, 10, 15 },
  {  0,  8, 11 },
  {  0,  6,  7 },
  {  2,  4,  3 },
  {  4,  2,  0 },
  {  6,  0,  0 },
  {  8,  0,  0 },
  { 10,  0,  0 },
};
int WIDTH = 100; /* `̈̕(=) */
int BSTEP =   5; /* 𑜓x(rbg)      */
int MAXIT =  50; /* Ce[V  */
void MandelSet( void )
{
  int    i, j, it;
  double x, y, zx, zy, u, v;
  /*
   * spilit up Eq.(1) into its real and imaginary parts yield,
   *
   * ZX = ZX^2 - ZY^2 + U,
   * ZY =   2*ZX*ZY   + V,
   *
   * with C = U + iV, Z = ZX + iZY.
   *
   */
  for ( i=0; i<WIDTH; i+=BSTEP ){
    u = vwx( i + BSTEP/2 );
    for ( j=0; j<WIDTH; j+=BSTEP ){
      v = vwy( j + BSTEP/2 );
      x = 0.0;
      y = 0.0;
      for ( it=0; it<MAXIT; it++ ){
        zx = x*x - y*y + u;
        zy =  2.0*x*y  + v;
        x = zx;
        y = zy;
        if ( ( x*x + y*y ) > 10.0 )
          break;
      }
      setfillstyle( SOLID_FILL, ( MAXIT-it )%16 );
      bar( i, j, i+BSTEP-1, j+BSTEP-1 );
    }
  }
}
void main( void )
{
  int gd = DETECT, gm, gmxx, gmxy, c;
  double rstart = -2.1, istart = 1.2, rend = 0.5, iend = -1.2;

  initgraph_( &gd, &gm, "C:\\BORLANDC\\BGI" );
  cleardevice();
  for( c=0; c<16; c++ ){
    setrgbpalette( c, mycolor[c][0], mycolor[c][1], mycolor[c][2] );
  }
  setcolor( 15 );
  setbkcolor( 0 );
  gmxx = getmaxx();
  gmxy = getmaxy();
  setviewport_( (gmxx+1)/2-WIDTH/2-1, (gmxy+1)/2-WIDTH/2-1,
               (gmxx+1)/2+WIDTH/2-1, (gmxy+1)/2+WIDTH/2-1, !0 );
  setwindow_( rstart, istart, rend, iend );
  printf( "x: from %8.5lf to %8.5lf\n", rstart, rend );
  printf( "y: from %8.5lf to %8.5lf\n", istart, iend );
  MandelSet();
  xbgiloop();
  /*(void)getchar();*/
  closegraph_();
}
