/*
 * Source File < graphix.c >
 *
 * Enhanced Functions: Borland Graphics Interface for Xlib
 *
 * Copyleft (c) 1993 Tokyo Denki University, Taiji Yamada
 */
#include <malloc.h>
#include <stdio.h>
#include <string.h>
#include "graphix.h"

extern xbgi *XBGIS;
extern xbgi *XBGI;

xbgi *creategraph( int *graphdriver, int *graphmode, char *pathtodriver )
{
  static int id = 0;
  xbgi *this;

  this = (xbgi*)malloc(sizeof(xbgi));
  this->id = id++;
  this->gerror = grNoInitGraph;
  /*
   * insert to linked list
   */
  this->next = XBGIS;
  XBGIS = this;
  /*
   * initialize of XBGI
   */
  XBGI = this;
  initgraph_xbgi( graphdriver, graphmode, pathtodriver );
  return( this );
}
xbgi *thisgraph( void )
{
  return( XBGI );
}
void currentgraph( xbgi *this )
{
  XBGI = this;
}
void destroygraph( xbgi *this )
{
  xbgi *ptr;

  XUnmapSubwindows( this->dpy, this->root );
  XUnmapWindow( this->dpy, this->root );
  XFlush( this->dpy );
  /*
   * delete from linked list
   */
  if ( XBGIS == this ){
    XBGIS = this->next;
    free( this );
    return;
  }
  ptr = XBGIS;
  while ( ptr->next != NULL ){
    if ( ptr->next == this ){
      ptr->next = this->next;
      XBGI = ptr;
      free( this );
      return;
    }
    ptr = ptr->next;
  }
  return;
}
